#!/bin/sh

# We need to do a lot of stuff like mount, mknod, and creating a symlink in
# the top level directory, which would ordinarily require root access.  But
# we can do all of this as a normal user by running User Mode Linux and doing
# the rest of the build in a virtual environment (within which we have root
# access).

cd tmpdir &&

echo "=== Create ext2 image for writeable UML workspace." &&
dd if=/dev/zero of=workspace.img bs=1024 count=1 seek=524287 &&
dd if=/dev/zero of=swap.img bs=1024 count=1 seek=262143 &&
/sbin/mkswap swap.img

echo "=== Build User Mode Linux."

mkdir uml-build &&
cd linux-* &&
make KCONFIG_ALLCONFIG=../../sources/system/linux-config-uml ARCH=um \
	O=../uml-build miniconfig &&
cd ../uml-build &&
make ARCH=um &&
mv linux .. &&
cd .. &&
rm -rf uml-build

if [ $? -ne 0 ]; then exit 1; fi
