#!/bin/sh

# This bit should be statically linked against uClibc...

cd tmpdir &&

gcc -s -Os ../sources/buildtools/marksize.c -o marksize &&

echo "=== Prepare Linux source for firmware build" &&

cd linux-* &&
mkdir initramfs 2> /dev/null
cp ../../sources/system/linux-initramfs.txt initramfs/initramfs.txt &&
# Strip the comment lines out of init script for space reasons.
grep -v "^[:space:]*# " ../../sources/system/ramfs-init.sh > initramfs/init.sh&&
cp ../initramfs-busybox initramfs/busybox &&
initramfsdir=$(pwd)/initramfs &&
cd ..

if [ $? -ne 0 ]; then exit 1; fi

architecture="ARCH=um"

for i in uml boot
do
  echo === Build $i

  mkdir -p $i-build
  ln -s "$initramfsdir" $i-build/initramfs

  cp ../sources/system/linux-config-$i $i-build/mini.config &&
  echo CONFIG_INITRAMFS_SOURCE='"'initramfs/initramfs.txt'"' >> $i-build/mini.config &&
  cd linux-* &&
  make KCONFIG_ALLCONFIG=../$i-build/mini.config O=../$i-build $architecture \
	miniconfig &&
  cd ../$i-build &&
  make $architecture &&
  if [ -f linux ]
  then
    strip linux -o ../../firmware-$i &&
    architecture=""
  else
    cp `find arch -name bzImage` ../../firmware-$i
  fi

  if [ $? -ne 0 ]; then exit 1; fi

  echo "=== Create firmware-"$i
  cd .. &&
  # rm -rf $i-build &&
  ls -l ../firmware-$i &&
  ./marksize ../firmware-$i &&
  cat build.sqf >> ../firmware-$i

  if [ $? -ne 0 ]; then exit 1; fi
done
